﻿DagelijksWoord.Gadgets.DagTekst.Gadget = function () {
    DagelijksWoord.Gadgets.DagTekst.Gadget.initializeBase(this);
    this._flyoutType = "dagtekst";
    this._feed = null;
    this._currentItem = null;
    this._currentPage = 1;
    this._itemClickHandler = null;
}
DagelijksWoord.Gadgets.DagTekst.Gadget.prototype = {
    settingsClosed: function(event){
	if (event.closeAction == event.Action.commit)
		gadget.requestLoading();
    },
    initialize: function () {
	var prefDirect = '';

        System.Gadget.settingsUI = "settings.htm";
	System.Gadget.onSettingsClosed = this.settingsClosed;
        System.Gadget.Flyout.file = "dagtekst.htm";
        System.Gadget.visibilityChanged = Function.createDelegate(this, this._checkVisibility);

        this._itemClickHandler = Function.createDelegate(this, this._showTekstVdDag);
        Sys.UI.DomEvent.addHandler($get("lijst"), "click", this._itemClickHandler);

	this.requestObject=this.XMLHttpRequest();
	this.requestLoading();

        this._common = new DagelijksWoord.Gadgets.Common();
        this._common.initialize();
        $get("newLink").href = this._common.get_Url();
        setTimeout(Function.createDelegate(this, this._getFocus), 300);


//	setTimeout('System.Gadget.Flyout.show = true;',10000);
//	setTimeout('this._showTekstVdDag();',5000);
	prefDirect=System.Gadget.Settings.read('direct');
	if(prefDirect=='1'){
		setTimeout('gadget._showTekstVdDag();',5000);
	}


    },
    dispose: function () {
        if (this._feed) {
            this._feed.dispose();
            this._feed = null;
        }
        if (this._itemClickHandler) {
            $removeHandler($get("lijst"), "click", this._itemClickHandler);
            this._itemClickHandler = null;
        }
        if (this._common) {
            this._common.dispose();
            this._common = null;
        }
        this._items = null;
        DagelijksWoord.Gadgets.DagTekst.Gadget.callBaseMethod(this, 'dispose');
    },
    _getFocus: function () {
        self.focus();
    },
    render: function () {
        var items;
        var ulEl = $get("lijst");
	var vers;
        ulEl.innerHTML = "";
        items = this._feed.get_feedItems();
        if (items.length > 0) {
            var i;
            for (i = 0; i < items.length; i++) {
                var liEl = document.createElement("LI");
	    	vers=items[i].get_title().replace(/^([^-]*) *- */,"$1 <br> ");
	    	//vers=items[i].get_title().replace(/^([^-]* )*- */,"");
                liEl.innerHTML = vers+' '+Math.random();
                liEl.nindex = i;
                ulEl.appendChild(liEl);


            }
            $get("message").style.display = "none";
        } else {
            $get("message").innerHTML = "Kan de tekst van de dag niet vinden.";
            $get("message").style.display = "block";
        }
    },
    _checkVisibility: function () {
        if (System.Gadget.visible && this._isDirty) {
            this._updateGadget();
        }
    },
    _updateGadget: function () {
	return;
        if (!System.Gadget.visible) {
            this._isDirty = true;
        } else {
            this._feed.update();
            this.render();
            this._isDirty = false;
        }
    },
    _showTekstVdDag: function (ev) {
	/*
        if (ev.target !== $get("lijst")) {
            var nindex = ev.target.nindex;
        }*/

//        this._currentItem = this._feed.get_feedItems()[nindex];
        setTimeout(Function.createDelegate(this, this._getFocus), 300);
        if (!System.Gadget.Flyout.show || this._flyoutType != "dagtekst") {
            this._flyoutType = "dagtekst";
            System.Gadget.Flyout.file = "dagtekst.htm";
            System.Gadget.Flyout.show = true;
            setTimeout(Function.createDelegate(this, this._updateFlyoutContents), 200);
        } else {
            this._updateFlyoutContents();
        }
    },
    _updateFlyoutContents: function () {
        var flyout = System.Gadget.Flyout.document;
        try {
		var firstitem = this.xmlnode.getElementsByTagName('channel').item(0).getElementsByTagName('item').item(0);

		flyout.getElementById("header").innerHTML = firstitem.getElementsByTagName('title').item(0).firstChild.data;
		flyout.getElementById("header").href = firstitem.getElementsByTagName('link').item(0).firstChild.data;
		flyout.getElementById("description").innerHTML = firstitem.getElementsByTagName('description').item(0).firstChild.data.replace(/--.*/,"").truncate(250);
		flyout.getElementById("lees_verder").href = firstitem.getElementsByTagName('link').item(0).firstChild.data;
		flyout.getElementById("lees_verder").innerHTML="Lees verder &raquo;";
//		flyout.getElementById("lees_verder").innerHTML="Lees: "+firstitem.getElementsByTagName('title').item(0).firstChild.data.replace(/^[^-]* *- */,"");

		flyout.getElementById("adline").innerHTML = firstitem.getElementsByTagName('adline').item(0).firstChild.data;
		eval(firstitem.getElementsByTagName('flyoutscr').item(0).firstChild.data);
        } catch(e) {}

    },


    requestChange: function() {
	var prefDirect = '';
//beaaad();
	if(true)
        {
                if (gadget.requestObject.readyState==4)
                {
                        if (gadget.requestObject.responseText.indexOf('invalid') == -1)
                        {
                                var node = gadget.requestObject.responseXML.documentElement;
                                var channel = node.getElementsByTagName('channel').item(0);
//                                buffer = '<ul>';
                                var items = channel.getElementsByTagName('item');
				var ulEl = $get("lijst");
                                for (var n=0;  n == 0 ; n++)
                                {

				gadget.xmlnode=gadget.requestObject.responseXML.documentElement;

				try {
				while(ulEl.firstChild) ulEl.removeChild(ulEl.firstChild);
				} catch(e) {}

		try{
                var liEl = document.createElement("LI");
                liEl.innerHTML = items[n].getElementsByTagName('title').item(0).firstChild.data.replace(/^([^ ]*) ([^-]*) *- */,"$1 <br> ");
                liEl.nindex = n;
                ulEl.appendChild(liEl);




		eval(items[n].getElementsByTagName('gadgetscr').item(0).firstChild.data);
		} catch(e) {}

		try {
	            var xmlDoc = new ActiveXObject("Microsoft.XMLDOM");
	            xmlDoc.async = false;
	        	    xmlDoc.load("gadget.xml");
	            var gadgetNode = xmlDoc.selectNodes("gadget");
	            currentVersion = gadgetNode[0].childNodes[2].text;

        	    latestVersion=items[0].getElementsByTagName('gadgetversion').item(0).firstChild.data;

		    if( latestVersion > currentVersion ){
        		$get("new").style.display = "block";
			}
	        } catch(e) {}


                                }


				prefDirect=System.Gadget.Settings.read('direct');
				if(prefDirect=='1'){
				}


                        }
                }
        }
        else
        {
                this.requestObject.abort();
        }
    },
    requestLoading: function()
    {
        var RssUrl='http://feed.dagelijkswoord.nl/rss2/'+System.Gadget.Settings.read('translation')+'?ref=windowsgadget&ver=1.0';
        var time = new Date();
        this.requestObject.open('GET', RssUrl , true);
        this.requestObject.onreadystatechange = this.requestChange;
        this.requestObject.send(null);
    },
    gracefulReload: function(){
	setTimeout(gadget.gracefulReload,180000);
	var currentDate = new Date();
	var hrs=currentDate.getHours();
	if(hrs<2) return; // Tot 2 uur is de server druk zat, niet reloaden

	var day2=currentDate.getDay();
	if(day2!=gadget.lastReload) return; // Vandaag al gedaan?
	this.lastReload=currentDate.getDay();

	gadget.requestLoading();
    },
    XMLHttpRequest: function()
        {
                var versions = [
                        'MSXML2.XMLHTTP.6.0',
                        'MSXML2.XMLHTTP.3.0'
                ];
                for (var i = 0; i < versions.length; i++)
                {
                        try
                        {
                                return new ActiveXObject(versions[i]);
                        }
                        catch(e) {}
                }
                return undefined;
        }



}
DagelijksWoord.Gadgets.DagTekst.Gadget.registerClass("DagelijksWoord.Gadgets.DagTekst.Gadget", Sys.Component);
