﻿DagelijksWoord.Gadgets.Common.Settings = function () {
    DagelijksWoord.Gadgets.Common.Settings.initializeBase(this);
    this._common = null;
}
DagelijksWoord.Gadgets.Common.Settings.prototype = {
    initialize: function () {
        this.render();
        this._common = new DagelijksWoord.Gadgets.Common();
	try{
        $get("newLink").href = this._common.get_Url();
	}catch(e) {}
        setTimeout(Function.createDelegate(this, this._getFocus), 300);
    },
    dispose: function () {
        if (this._common) {
            this._common.dispose();
            this._common = null;
        }
        DagelijksWoord.Gadgets.Common.Settings.callBaseMethod(this, 'dispose');
    },
    _getFocus: function () {
        self.focus();
    },
    render: function () {
        var xmlDoc = new ActiveXObject("Microsoft.XMLDOM");
        xmlDoc.async = false;
        xmlDoc.load("gadget.xml");
        var gadget = xmlDoc.selectNodes("gadget");
        $get("naam").innerHTML = gadget[0].childNodes[0].text;
        $get("versie").innerHTML = "versie " + gadget[0].childNodes[2].text;
    }
}
DagelijksWoord.Gadgets.Common.Settings.registerClass('DagelijksWoord.Gadgets.Common.Settings', Sys.Component);


var prefTranslation = '';
var prefDirect = '';

System.Gadget.onSettingsClosing = settingsClosing;
function loadSettings()
{
        if (System.Gadget.Settings.read('translation') != '') prefTranslation = System.Gadget.Settings.read('translation');

        for (var i=0; i<translation.options.length; i++)
                if (translation.options[i].value == prefTranslation)
                        translation.selectedIndex = i;

        if (System.Gadget.Settings.read('direct') != '') prefDirect = System.Gadget.Settings.read('direct');


        for (var i=0; i<direct.options.length; i++)
                if (direct.options[i].value == prefDirect)
                        direct.selectedIndex = i;
}

function settingsClosing(event)
{
        if (event.closeAction == event.Action.commit){
                System.Gadget.Settings.write('translation', translation.value);
                System.Gadget.Settings.write('direct', direct.value);
	}
}

